# Class Md5CalculatingInputStream

java.lang.Object
java.io.InputStream
htsjdk.samtools.util.Md5CalculatingInputStream

All Implemented Interfaces:
  `Closeable, AutoCloseable`

public class Md5CalculatingInputStream extends InputStream
Class to generate an MD5 string for a file as it is being read

## Constructor Summary

Constructors
Constructor
Description
`Md5CalculatingInputStream(InputStream is, File digestFile)`
Constructor that takes in the InputStream that we are wrapping and creates the MD5 MessageDigest

## Method Summary

Modifier and Type
Method
Description
`int`
`available()`
`void`
`close()`
`void`
`mark(int readlimit)`
`boolean`
`markSupported()`
`String`
`md5()`
`int`
`read()`
`int`
`read(byte[] b)`
`int`
`read(byte[] b, int off, int len)`
`void`
`reset()`
`long`
`skip(long n)`

### Methods inherited from class InputStream

`nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Md5CalculatingInputStream

public Md5CalculatingInputStream(InputStream is, File digestFile)
Constructor that takes in the InputStream that we are wrapping and creates the MD5 MessageDigest

## Method Details

### read

public int read() throws IOException

Specified by:
  `read` in class `InputStream`
Throws:
  `IOException`

### read

public int read(byte[] b) throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`

### read

public int read(byte[] b, int off, int len) throws IOException

Overrides:
  `read` in class `InputStream`
Throws:
  `IOException`

### md5

public String md5()

### close

public void close() throws IOException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `InputStream`
Throws:
  `IOException`

### markSupported

public boolean markSupported()

Overrides:
  `markSupported` in class `InputStream`

### mark

public void mark(int readlimit)

Overrides:
  `mark` in class `InputStream`

### reset

public void reset() throws IOException

Overrides:
  `reset` in class `InputStream`
Throws:
  `IOException`

### skip

public long skip(long n) throws IOException

Overrides:
  `skip` in class `InputStream`
Throws:
  `IOException`

### available

public int available() throws IOException

Overrides:
  `available` in class `InputStream`
Throws:
  `IOException`